﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.IO.Ports;

//namespace BobSerialTest11
namespace WindowsFormsApplication1
{
    //public class serial2 { };
    public partial class SerialTest : Form
    {
        Byte[] cmdreadoffset = new Byte[4] { 0x2D, 0x04, 0x00, 0x29 };
        Byte[] cmdsendtempoffset = new Byte[4] { 0x2e, 0x09, 0x00, 0x27 };
        Byte[] cmdsendpermoffset = new Byte[4] { 0x2c, 0x09, 0x00, 0x25 };
        public Byte entermsb1, entermsb2, enterlsb1, enterlsb2;
        int TICKS = 1;  //No. of timer 100ms intervals
        int[] RecBuff = new int[32];
        string[] StringBuff = new string[32];

        //public int Baudrate;
        Byte chksum = 0;
        //static SerialPort _serialPort;
        public string[] ports;

        CommsProperty.Form1 cp = new CommsProperty.Form1();
        WindowsFormsApplication1.AboutBox1 Help = new WindowsFormsApplication1.AboutBox1();
        public SerialTest()
        {
            

            InitializeComponent();
            {
                this.serialPort1 = new SerialPort("COM1", 9600);
                // Get first installed port on this machine.
                ports = SerialPort.GetPortNames();
                serialPort1.PortName = (ports[0]);
                // Allow the user to set the appropriate properties.
                serialPort1.BaudRate = 9600;
                //serialPort1.Parity = 1;
                serialPort1.DataBits = 8;
                //serialPort1.StopBits = 1;
                //serialPort1.Handshake = "NONE";

                // Set the read/write timeouts
                serialPort1.ReadTimeout = 500;
                serialPort1.WriteTimeout = 500;
                cp.PortName = serialPort1.PortName;
            }
        }
        private void ReadOffset_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
            try
            {
                serialPort1.Write(cmdreadoffset, 0, 4);
            }
            catch (System.Exception ex)
            {
                this.label2.ForeColor = System.Drawing.Color.Red;
                label2.Text = ex.Message;
            }
            // Clear previous text
            this.textBox1.Text = "";
            this.timer1.Start();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void SendTempOffset_Click(object sender, EventArgs e)
        {
            Byte[] TempBuff = new Byte[32];
            TempBuff[0] = this.entermsb1;
            TempBuff[1] = this.entermsb2;
            TempBuff[2] = this.enterlsb1;
            TempBuff[3] = this.enterlsb2;
            TempBuff[4] = this.chksum;
            try
            {
                serialPort1.Write(cmdsendtempoffset, 0, 4);
                serialPort1.Write(TempBuff, 0, 5);
            }
            catch (System.Exception ex)
            {
                this.label2.ForeColor = System.Drawing.Color.Red;
                label2.Text = ex.Message;
            }

        }

        public int DoChecksum()
        {
           
            {
                this.chksum = 0;
                this.chksum ^= this.entermsb1;
                this.chksum ^= this.entermsb2;
                this.chksum ^= this.enterlsb1;
                this.chksum ^= this.enterlsb2;
                this.textBox2.Text = String.Format("{0:X2}", this.chksum);
                throw new NotImplementedException();
            }
        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            string inptext = this.textBox3.Text;
            if (inptext == "")
            { inptext = "00"; }    
            this.entermsb2 = Byte.Parse(inptext, System.Globalization.NumberStyles.HexNumber);
            try
            {
                DoChecksum();
            }
            catch
            {
                new NotImplementedException();
            }
        }

        private void textBox4_TextChanged(object sender, EventArgs e)
        {
            string inptext = this.textBox4.Text;
            if (inptext == "")
            { inptext = "00"; }
            this.enterlsb1 = Byte.Parse(inptext, System.Globalization.NumberStyles.HexNumber);
            try
            {
                DoChecksum();
            }
            catch
            {
                new NotImplementedException();
            }
        }

        private void textBox5_TextChanged(object sender, EventArgs e)
        {
            string inptext = this.textBox5.Text;
            if (inptext == "")
            { inptext = "00"; }    
            this.enterlsb2 = Byte.Parse(inptext, System.Globalization.NumberStyles.HexNumber);
            try
            {
                DoChecksum();
            }
            catch
            {
                new NotImplementedException();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Byte[] TempBuff = new Byte[32];
            TempBuff[0] = this.entermsb1;
            TempBuff[1] = this.entermsb2;
            TempBuff[2] = this.enterlsb1;
            TempBuff[3] = this.enterlsb2;
            TempBuff[4] = this.chksum;
            try
            {
                serialPort1.Write(cmdsendpermoffset, 0, 4);
                serialPort1.Write(TempBuff, 0, 5);
            }
            catch (System.Exception ex)
            {
                this.label2.ForeColor = System.Drawing.Color.Red;
                label2.Text = ex.Message;
            }

        }

        private void textBox2_TextChanged_1(object sender, EventArgs e)
        {

        }

        private void textBox6_TextChanged(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.cp.BaudRate = serialPort1.BaudRate;
            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
            }
            cp.ShowDialog();
            serialPort1.PortName = cp.PortName;
            this.label3.Text = "Port = " + serialPort1.PortName;
            this.label2.ForeColor = System.Drawing.Color.Black;
            this.label2.Text = "No Error";  //Clear error notification
            try
            {
                //open serial port
                serialPort1.Open();
            }
            catch (System.Exception ex)
            {
                this.label2.ForeColor = System.Drawing.Color.Red;
                label2.Text = ex.Message;
            }
        }

        private void textBox6_TextChanged_1(object sender, EventArgs e)
        {
            string inptext = this.textBox6.Text;
            if (inptext == "")
            { inptext = "00"; }    
            this.entermsb1 = Byte.Parse(inptext, System.Globalization.NumberStyles.HexNumber);
            try
            {
                DoChecksum();
            }
            catch
            {
                new NotImplementedException();
            }
            //DoChecksum;
        }

        private void SerialTest_Load(object sender, EventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void button3_Click(object sender, EventArgs e)
        {
            //Exit out
            this.serialPort1.Close();
            this.Close();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // read all bytes in rec buffer after timer
            int Count = 0;
            int Rbits = 0;

            // Runs the timer, and raises the event.
            while (Count <= TICKS)
            {
                // Processes all the events in the queue.
                Count++;
            }
            try
            {
                Rbits = serialPort1.BytesToRead;
            }
            catch (System.Exception ex)
            {
                this.label2.ForeColor = System.Drawing.Color.Red;
                label2.Text = ex.Message;
            }
            for (int i = 0; i <= (Rbits - 1); i++)
            {
                int xxxx = serialPort1.ReadByte();
                RecBuff[i] = xxxx;
                StringBuff[i] = String.Format("{0:X2} ", xxxx);
                this.textBox1.AppendText(StringBuff[i]);
            }

            this.timer1.Stop();
            return;

        }

        private void button4_Click(object sender, EventArgs e)
        {
            Help.ShowDialog();
        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            //Read UpDown and place Hex Bytes in approp Textboxes
            Int64 x = (int)numericUpDown1.Value;
            Byte y = (Byte)x;
            this.textBox5.Text = String.Format("{0:X2}", y);
            y = (Byte)(x >> 8);
            this.textBox4.Text = String.Format("{0:X2}", y);
            y = (Byte)(x >> 16);
            this.textBox3.Text = String.Format("{0:X2}", y);
            y = (Byte)(x >> 24);
            this.textBox6.Text = String.Format("{0:X2}", y);
        }
    }
}
